poj3126 Prime Path(bfs+40入口+素数判定)

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input

3
1033 8179
1373 8017
1033 1033
Sample Output

6
7
0
题意:(素数)n(四位数)每次改变一位数直到变成(素数)m,求最少的操作

#include<stdio.h>
#include<cmath>
#include<string>
#include<string.h>
#include<queue>
#include<iostream>
#include<algorithm>
using namespace std;
int n,m;
struct node
{
    int prime;
    int step;
};
int vist[10000];
int judge(int yy)//判断素数
{
    int flag=1;
    for(int i=2; i<=sqrt(yy); i++)
    {
        if(yy%i==0)
        {
            flag=0;
            break;
        }
    }
    return flag;
}
void dfs(int x)//普通的dfs操作
{
    vist[x]=1;
    node now,next;
    queue<node>q;
    now.prime=x,now.step=0;
    q.push(now);
    while(!q.empty())
    {
        now=q.front();
        q.pop();
        int y=now.prime;
        int stepp=now.step;
        if(y==m)
        {
            printf("%d
",stepp);
            return ;
        }
        for(int i=1; i<=9; i+=2)
        {
            int yy=y/10*10+i;
            if(!vist[yy]&&judge(yy))
            {
                vist[yy]=1;
                next.prime=yy;
                next.step=stepp+1;
                q.push(next);
            }
        }
        for(int i=0; i<=9; i++)
        {
            int yy=y/100*100+y%10+10*i;
            if(!vist[yy]&&judge(yy))
            {
                vist[yy]=1;
                next.prime=yy;
                next.step=stepp+1;
                q.push(next);
            }
        }
        for(int i=0; i<=9; i++)
        {
            int yy=y/1000*1000+y%100+100*i;
            if(!vist[yy]&&judge(yy))
            {
                vist[yy]=1;
                next.prime=yy;
                next.step=stepp+1;
                q.push(next);
            }
        }
        for(int i=1; i<=9; i++)
        {
            int yy=y%1000+1000*i;
            if(!vist[yy]&&judge(yy))
            {
                vist[yy]=1;
                next.prime=yy;
                next.step=stepp+1;
                q.push(next);
            }
        }
    }
    printf("Impossible
");
    return ;
}
int main()
{
    int t;
    scanf("%d",&t);
    while(t--)
    {
        memset(vist,0,sizeof(vist));
        scanf("%d%d",&n,&m);
        dfs(n);
    }
    return 0;
}
原文地址:https://www.cnblogs.com/zxy160/p/7215102.html